searchNodes=[{"doc":"The EctoCommand module provides a DSL for defining command schemas. It is used by use EctoCommand in your command modules. Example defmodule MyApp.Commands.CreatePost do use EctoCommand alias MyApp.PostRepository command do param :title , :string , required : true , length : [ min : 3 , max : 255 ] param :body , :string , required : true , length : [ min : 3 ] internal :slug , :string internal :author , :string end def execute ( % __MODULE__ { } = command ) do ... :ok end def fill ( :slug , _changeset , %{ &quot;title&quot; =&gt; title } , _metadata ) do Slug . slufigy ( title ) end def fill ( :author , _changeset , _params , %{ &quot;triggered_by&quot; =&gt; triggered_by } ) do triggered_by end def fill ( :author , changeset , _params , _metadata ) do Ecto.Changeset . add_error ( changeset , :triggered_by , &quot;triggered_by metadata info is missing&quot; ) end end","ref":"EctoCommand.html","title":"EctoCommand","type":"module"},{"doc":"The command/1 macro defines a command schema with the given block. Examples command do param :name , :string param :age , :integer end","ref":"EctoCommand.html#command/1","title":"EctoCommand.command/1","type":"macro"},{"doc":"Defines a command internal field. These fields will be ignored during the &quot;cast process&quot;. Instead, you need to define a public fill/4 function to populate them. The fill/4 function takes four arguments: the name of the field, the current temporary changeset, the parameters received from external sources, and additional metadata. You can choose to return the value that will populate the field or the updated changeset. Both options are acceptable, but returning the changeset is particularly useful if you want to add errors to it. Examples internal :slug , :string internal :author , :string","ref":"EctoCommand.html#internal/3","title":"EctoCommand.internal/3","type":"macro"},{"doc":"Defines a command parameter field. The param macro is based on the field macro of Ecto.Schema and defines a field in the schema with a given name and type. You can pass all the options supported by the field macro. Afterwards, each defined param is cast with the &quot;external&quot; data received. In addition to those options, the param macro accepts a set of other options that indicate how external data for that field should be validated. These options are applied to the intermediate Changeset created in order to validate data. These options are mapped into validate_* methods of the Ecto.Changeset . Examples param :title , :string , required : true , length : [ min : 3 , max : 255 ] param :body , :string , required : true , length : [ min : 3 ]","ref":"EctoCommand.html#param/3","title":"EctoCommand.param/3","type":"macro"},{"doc":"","ref":"EctoCommand.html#validate_with/2","title":"EctoCommand.validate_with/2","type":"macro"},{"doc":"Middleware provides an extension point to add functions that you want to be called for every command execution Implement the EctoCommand.Middleware behaviour in your module and define the before_execution/2 , after_execution/2 , after_failure/2 and invalid/2 callback functions. Example middleware defmodule SampleMiddleware do @behaviour EctoCommand.Middleware @impl true def before_execution ( pipeline , _opts ) do pipeline |&gt; Pipeline . assign ( :some_data , :some_value ) |&gt; Pipeline . update! ( :command , fn command -&gt; %{ command | name : &quot;updated-name&quot; } end ) end def after_execution ( pipeline , _opts ) do Logger . debug ( &quot;Command executed successfully&quot; , command : pipeline . command , result : Pipeline . response ( pipeline ) ) pipeline end def after_failure ( pipeline , _opts ) do Logger . error ( &quot;Command execution fails&quot; , command : pipeline . command , error : Pipeline . response ( pipeline ) ) pipeline end def invalid ( pipeline , _opts ) do Logger . error ( &quot;invalid params received&quot; , params : pipeline . params , error : Pipeline . response ( pipeline ) ) pipeline end end","ref":"EctoCommand.Middleware.html","title":"EctoCommand.Middleware","type":"behaviour"},{"doc":"","ref":"EctoCommand.Middleware.html#c:after_execution/2","title":"EctoCommand.Middleware.after_execution/2","type":"callback"},{"doc":"","ref":"EctoCommand.Middleware.html#c:after_failure/2","title":"EctoCommand.Middleware.after_failure/2","type":"callback"},{"doc":"","ref":"EctoCommand.Middleware.html#c:before_execution/2","title":"EctoCommand.Middleware.before_execution/2","type":"callback"},{"doc":"","ref":"EctoCommand.Middleware.html#c:invalid/2","title":"EctoCommand.Middleware.invalid/2","type":"callback"},{"doc":"","ref":"EctoCommand.Middleware.html#t:pipeline/0","title":"EctoCommand.Middleware.pipeline/0","type":"type"},{"doc":"Pipeline is a struct used as an argument in the callback functions of modules implementing the EctoCommand.Middleware behaviour. This struct must be returned by each function to be used in the next middleware based on the configured middleware chain. Pipeline fields assigns - shared user data as a map. command_uuid - UUID assigned to the command being executed. command - command struct being executed. params - raw params received to instantiate the command metadata - additional metadata, they could be used to fill internal command fields halted - flag indicating whether the pipeline was halted. handler - handler module where the &quot;execute/1&quot; function resides middlewares - the list of middlewares to be executed response - sets the response to send back to the caller. error - sets the error to send back to the caller.","ref":"EctoCommand.Middleware.Pipeline.html","title":"EctoCommand.Middleware.Pipeline","type":"module"},{"doc":"Puts the key with value equal to value into assigns map. Examples iex&gt; pipeline = assign ( % Pipeline { } , :foo , :bar ) iex&gt; pipeline . assigns %{ foo : :bar }","ref":"EctoCommand.Middleware.Pipeline.html#assign/3","title":"EctoCommand.Middleware.Pipeline.assign/3","type":"function"},{"doc":"Executes the middleware chain.","ref":"EctoCommand.Middleware.Pipeline.html#chain/3","title":"EctoCommand.Middleware.Pipeline.chain/3","type":"function"},{"doc":"Sets the error Examples iex&gt; pipeline = % Pipeline { } iex&gt; pipeline = Pipeline . error ( pipeline , &quot;an_error&quot; ) iex&gt; Pipeline . response ( pipeline ) { :error , &quot;an_error&quot; }","ref":"EctoCommand.Middleware.Pipeline.html#error/2","title":"EctoCommand.Middleware.Pipeline.error/2","type":"function"},{"doc":"Executes the function 'execute/1' in the handler module, pass the command to it. Halt the pipeline if command or handler are not set Examples iex&gt; % Pipeline { halted : true } = Pipeline . execute ( % Pipeline { halted : true } ) iex&gt; % Pipeline { response : { :error , &quot;command was not initialized&quot; } } = Pipeline . execute ( % Pipeline { handler : Pipeline } ) iex&gt; % Pipeline { response : { :error , &quot;handler was not set&quot; } } = Pipeline . execute ( % Pipeline { command : %{ } } ) iex&gt; % Pipeline { response : { :ok , :result } } = Pipeline . execute ( % Pipeline { handler : SampleCommand , command : % SampleCommand { } } )","ref":"EctoCommand.Middleware.Pipeline.html#execute/1","title":"EctoCommand.Middleware.Pipeline.execute/1","type":"function"},{"doc":"Halts the pipeline by preventing further middleware downstream from being invoked. Prevents execution of the command if halt occurs in a before_execution callback. Examples iex&gt; pipeline = % Pipeline { } iex&gt; pipeline = halt ( pipeline ) iex&gt; halted? ( pipeline ) true","ref":"EctoCommand.Middleware.Pipeline.html#halt/1","title":"EctoCommand.Middleware.Pipeline.halt/1","type":"function"},{"doc":"Halts the pipeline by preventing further middleware downstream from being invoked. Prevents execution of the command if halt occurs in a before_execution callback. Similar to halt/1 but allows a response to be returned to the caller. Examples iex&gt; pipeline = % Pipeline { } iex&gt; pipeline = halt ( pipeline , { :error , &quot;halted&quot; } ) iex&gt; response ( pipeline ) { :error , &quot;halted&quot; } iex&gt; halted? ( pipeline ) true","ref":"EctoCommand.Middleware.Pipeline.html#halt/2","title":"EctoCommand.Middleware.Pipeline.halt/2","type":"function"},{"doc":"Has the pipeline been halted? Examples iex&gt; true = halted? ( % Pipeline { halted : true } ) iex&gt; false = halted? ( % Pipeline { halted : false } )","ref":"EctoCommand.Middleware.Pipeline.html#halted?/1","title":"EctoCommand.Middleware.Pipeline.halted?/1","type":"function"},{"doc":"Sets the response to be returned to the dispatch caller Examples iex&gt; pipeline = % Pipeline { } iex&gt; pipeline = Pipeline . respond ( pipeline , { :error , &quot;halted&quot; } ) iex&gt; Pipeline . response ( pipeline ) { :error , &quot;halted&quot; }","ref":"EctoCommand.Middleware.Pipeline.html#respond/2","title":"EctoCommand.Middleware.Pipeline.respond/2","type":"function"},{"doc":"Extract the response from the pipeline, return the error if it is set return the stored response otherwise return nil if no response is set Examples iex&gt; pipeline = % Pipeline { } iex&gt; pipeline = Pipeline . error ( pipeline , &quot;halted&quot; ) iex&gt; Pipeline . response ( pipeline ) { :error , &quot;halted&quot; }","ref":"EctoCommand.Middleware.Pipeline.html#response/1","title":"EctoCommand.Middleware.Pipeline.response/1","type":"function"},{"doc":"Set the key with value Examples iex&gt; pipeline = set ( % Pipeline { } , :command , :my_command ) iex&gt; pipeline . command :my_command","ref":"EctoCommand.Middleware.Pipeline.html#set/3","title":"EctoCommand.Middleware.Pipeline.set/3","type":"function"},{"doc":"Update the key with function function that receive the key value. Examples iex&gt; pipeline = % Pipeline { command : %{ name : &quot;original&quot; } } iex&gt; pipeline = update! ( pipeline , :command , fn command -&gt; %{ command | name : &quot;updated&quot; } end ) iex&gt; pipeline . command %{ name : &quot;updated&quot; }","ref":"EctoCommand.Middleware.Pipeline.html#update!/3","title":"EctoCommand.Middleware.Pipeline.update!/3","type":"function"},{"doc":"EctoCommand is a toolkit for mapping, validating, and executing commands received from any source. It provides a simple and flexible way to define and execute commands in Elixir. With support for validation, middleware, and automatic OpenAPI documentation generation, it's a valuable tool for building scalable and maintainable Elixir applications. We hope you find it useful!","ref":"readme.html","title":"EctoCommand","type":"extras"},{"doc":"To install EctoCommand, add it as a dependency to your project by adding ecto_command to your list of dependencies in mix.exs : def deps do [ { :ecto_command , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"EctoCommand - Installation","type":"extras"},{"doc":"&quot;Ecto is also commonly used to map data from any source into Elixir structs, whether they are backed by a database or not.&quot; Based on this definition of the Ecto library, EctoCommand utilizes the &quot;embedded_schema&quot; functionality to map input data into an Elixir data structure to be used as a &quot;command&quot;. This means that EctoCommand is not tied to your persistence layer . As a result, you can easily convert data received from any source into a valid command struct, which can be executed easily. Additionally, you can also add functionality through middlewares to the execution pipeline. Here is an example of a command definition: defmodule SampleCommand do use EctoCommand command do param :id , :string param :name , :string , required : true , length : [ min : 2 , max : 255 ] param :email , :string , required : true , format : ~r/@/ , length : [ min : 6 ] param :count , :integer , required : true , number : [ greater_than_or_equal_to : 18 , less_than : 100 ] param :password , :string , required : true , length : [ greater_than_or_equal_to : 8 , less_than : 100 ] , trim : true internal :hashed_password , :string end def execute ( % SampleCommand { } = command ) do # .... :ok end def fill ( :hashed_password , _changeset , %{ &quot;password&quot; =&gt; password } , _metadata ) do :crypto . hash ( :sha256 , password ) |&gt; Base . encode64 ( ) end end :ok = SampleCommand . execute ( %{ id : &quot;aa-bb-cc&quot; , name : &quot;foobar&quot; , email : &quot;foo@bar.com&quot; , count : 22 , password : &quot;mysecret&quot; } )","ref":"readme.html#why-ecto","title":"EctoCommand - Why Ecto?","type":"extras"},{"doc":"Defining a Command To define a new command, create a module that includes the EctoCommand behaviour and implements the execute/1 function. The execute/1 function takes the command structure as an argument. The command macro is used to define the parameters included in the command. The param macro is used to define which parameters are accepted by the command , and the internal macro is used to define which parameters are internally set . defmodule MyApp.Commands.CreatePost do use EctoCommand alias MyApp.PostRepository command do param :title , :string , required : true , length : [ min : 3 , max : 255 ] param :body , :string , required : true , length : [ min : 3 ] internal :slug , :string internal :author , :string end def execute ( % __MODULE__ { } = command ) do PostRepository . insert ( %{ title : command . title , body : command . body , slug : command . slug } ) end def fill ( :slug , _changeset , %{ &quot;title&quot; =&gt; title } , _metadata ) do Slug . slufigy ( title ) end def fill ( :author , _changeset , _params , %{ &quot;triggered_by&quot; =&gt; triggered_by } ) do triggered_by end def fill ( :author , changeset , _params , _metadata ) do Ecto.Changeset . add_error ( changeset , :triggered_by , &quot;triggered_by metadata info is missing&quot; ) end end Executing a Command In order to execute the command, you need to call the execute/2 function providing a raw parameter data map and, optionally, some metadata. params = %{ title : &quot;New amazing post&quot; , body : &quot;Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut eget ante odio.&quot; } metadata = %{ triggered_by : &quot;writer&quot; } :ok = MyApp.Commands.CreatePost . execute ( params , metadata ) This data is validated, and if it passes all validation rules, a new command structure is created and passed as an argument to the execute/1 function defined inside your command module. Handling Errors If a required parameter is missing or has an invalid value, the EctoCommand.execute/2 function will return an error tuple with an invalid Ecto.Changeset structure. You can then use the changeset to return errors to the client or perform other actions. { :error , % Ecto.Changeset { valid? : false } } = MyApp.Commands.CreatePost . execute . execute ( %{ } ) Returning an invalid Ecto.Changeset is particularly useful when working with Phoenix forms.","ref":"readme.html#usage","title":"EctoCommand - Usage","type":"extras"},{"doc":"EctoCommand aims to provide the following functionality: An easy way to define the fields in a command ( param macro). A simple and compact way of specifying how these fields should be validated ( param macro options) Defining the fields that need to be part of the command but can't be set from the outside ( internal macro) Validation of the params received from the outside Easy hooking of middleware to add functionality (like audit) Automatic generation of OpenApi documentation","ref":"readme.html#main-goals-and-functionality-of-ectocommand","title":"EctoCommand - Main goals and functionality of EctoCommand","type":"extras"},{"doc":"To define the params that a command should accept, use the param macro. The param macro is based on the field macro of Ecto.Schema and defines a field in the schema with a given name and type. You can pass all the options supported by the field macro. Afterwards, each defined param is cast with the &quot;external&quot; data received.","ref":"readme.html#params-definition","title":"EctoCommand - Params definition","type":"extras"},{"doc":"In addition to those options, the param macro accepts a set of other options that indicate how external data for that field should be validated. These options are applied to the intermediate Changeset created in order to validate data. These options are mapped into validate_* methods of the Ecto.Changeset . For example, if you want a command to have a &quot;name&quot; field that is required and has a length between 2 and 255 chars, you can write: param :name, :string, required: true, length: [min: 2, max: 255] This means that the command will have a name field, which will be cast to a string type. These functions will be called during the changeset validation: changeset |&gt; validate_required([:name]) |&gt; validate_length(:name, min: 2, max: 255) for validators that accept both data and options, you could pass just data like: param :email , :string , format : ~r/@/ or data and options in this way: param :email , :string , format : { ~r/@/ , message : &quot;my custom error message&quot; }","ref":"readme.html#validations-and-constraints-definition","title":"EctoCommand - Validations and constraints definition","type":"extras"},{"doc":"Sometimes, you might need to define internal fields, like hashed_password or triggered_by , which are not supposed to be set externally. To define such fields, you can use the internal macro. command do param :password , :string , required : true , length : [ greater_than_or_equal_to : 8 , less_than : 100 ] , trim : true internal :hased_password , :string internal :triggered_by , :string end def fill ( :hased_password , _changeset , %{ &quot;password&quot; =&gt; password } , _metadata ) do :crypto . hash ( :sha256 , password ) |&gt; Base . encode64 ( ) end def fill ( :triggered_by , _changeset , _params , %{ &quot;triggered_by&quot; : triggered_by } ) do triggered_by end def fill ( :triggered_by , changeset , _params , _metadata ) do Ecto.Changeset . add_error ( changeset , :triggered_by , &quot;triggered_by metadata info is missing&quot; ) end These fields will be ignored during the &quot;cast process&quot;. Instead, you need to define a public fill/4 function to populate them. The fill/4 function takes four arguments: the name of the field, the current temporary changeset, the parameters received from external sources, and additional metadata. You can choose to return the value that will populate the field or the updated changeset. Both options are acceptable, but returning the changeset is particularly useful if you want to add errors to it.","ref":"readme.html#internal-fields","title":"EctoCommand - Internal fields","type":"extras"},{"doc":"All parameters are validated in order to instantiate the command structure. When you use EctoCommand inside your module, three methods are added: changeset/2 new/2 execute/2 All three methods take parameter data and metadata as arguments. The changeset/2 function performs validation and other operations, and returns a valid or invalid Ecto.Changeset . The new/2 function internally calls the changeset/2 function and returns either the valid command structure or the invalid Ecto.Changeset . The execute/2 function internally calls the new/2 function and then calls the execute/1 function (which should be defined inside the command module), or returns the invalid Ecto.Changeset .","ref":"readme.html#validations","title":"EctoCommand - Validations","type":"extras"},{"doc":"EctoCommand supports middlewares, which allow you to modify the behavior of a command before and/or after its execution. A middleware is a module that implements the EctoCommand.Middleware behavior. Here's how you can use middlewares in your EctoCommand project: defmodule MyApp.MyMiddleware do @behaviour EctoCommand.Middleware @impl true def before_execution ( pipeline , _opts ) do pipeline |&gt; Pipeline . assign ( :some_data , :some_value ) |&gt; Pipeline . update! ( :command , fn command -&gt; %{ command | name : &quot;updated-name&quot; } end ) end @impl true def after_execution ( pipeline , _opts ) do Logger . debug ( &quot;Command executed successfully&quot; , command : pipeline . command , result : Pipeline . response ( pipeline ) ) pipeline end @impl true def after_failure ( pipeline , _opts ) do Logger . error ( &quot;Command execution fails&quot; , command : pipeline . command , error : Pipeline . response ( pipeline ) ) pipeline end @impl true def invalid ( pipeline , _opts ) do Logger . error ( &quot;invalid params received&quot; , params : pipeline . params , error : Pipeline . response ( pipeline ) ) pipeline end end Each method takes two arguments: an EctoCommand.Pipeline structure and the options you set for that middleware. The method should return an EctoCommand.Pipeline structure. before_execution/2 is executed before command execution, it is executed only if the command is valid. In this function you could, if you wish, also update the command that will be executed. after_execution/2 is executed after command successfully execution. In this function you could, if you wish, also update the returned value. after_failure/2 is executed after command successfully execution. In this function you could, if you wish, also update the returned value. invalid/2 is executed when data to build the command is invalid. Configuring Middlewares There are two ways to specify which middleware should be executed: Global configuration: You can set up a list of middleware to be executed for every command by adding the following to your application's configuration: config :ecto_command , :middlewares , { MyApp.MyFirstMiddleware , a_middleware_option : :foo } , { MyApp.MySecondMiddleware , a_middleware_option : :bar } Command-level configuration: You can also specify middleware to be executed for a specific command by adding the use directive in the command module: defmodule MyApp.MyCommand do use EctoCommand use MyApp.MyFirstMiddleware , a_middleware_option : :foo use MyApp.MySecondMiddleware , a_middleware_option : :bar ... . end In this case, the specified middleware is executed only for that particular command.","ref":"readme.html#using-middlewares-in-ectocommand","title":"EctoCommand - Using Middlewares in EctoCommand","type":"extras"},{"doc":"EctoCommand has a built-in feature that automatically generates OpenAPI documentation based on the parameters and validation rules defined in your command modules. This can save you a significant amount of time and effort in writing and maintaining documentation, particularly if you have a large number of commands. To generate the OpenAPI schema, you can use the EctoCommand.OpenApi module: use EctoCommand.OpenApi By default, the schema's title is the fully qualified domain name (FQDN) of the module, and the default type is :object . However, you can override the defaults by passing options to the use module: use EctoCommand.OpenApi , title : &quot;CustomTitle&quot; , type : :object Then in your controller you can simply pass your command module to the request body specs: defmodule MyAppWeb.PostController do use MyAppWeb , :controller use OpenApiSpex.ControllerSpecs alias MyApp.Commands.CreatePost operation :create_post , summary : &quot;Create a Post&quot; , request_body : { &quot;Post params&quot; , &quot;application/json&quot; , CreatePost } , responses : [ ok : { &quot;Post response&quot; , &quot;application/json&quot; , [ ] } , bad_request : { &quot;Post response&quot; , &quot;application/json&quot; , [ ] } ] def create_post ( conn , params ) do ... end For more information on serving the Swagger UI, please refer to the readme of the open-api-spex library.","ref":"readme.html#automated-generation-of-openapi-documentation","title":"EctoCommand - Automated generation of OpenAPI documentation","type":"extras"},{"doc":"Contributions are always welcome! Please feel free to submit a pull request or create an issue if you find a bug or have a feature request.","ref":"readme.html#contributing","title":"EctoCommand - Contributing","type":"extras"},{"doc":"This library is licensed under the MIT license. See LICENSE for more details.","ref":"readme.html#license","title":"EctoCommand - License","type":"extras"}]